# OpalIVREndPoint Class Reference

`#include <ivr.h>`

Inheritance diagram for OpalIVREndPoint:

[legend]
Collaboration diagram for OpalIVREndPoint:
[legend]

## Public Member Functions

virtual PVXMLCache & | GetTextToSpeechCache ()
Construction
| OpalIVREndPoint (OpalManager &manager, const char *prefix="ivr")
| ~OpalIVREndPoint ()
Overrides from OpalEndPoint
virtual PSafePtr< OpalConnection > | MakeConnection (OpalCall &call, const PString &party, void *userData=NULL, unsigned int options=0, OpalConnection::StringOptions *stringOptions=NULL)
virtual OpalMediaFormatList | GetMediaFormats () const
Customisation call backs
virtual OpalIVRConnection * | CreateConnection (OpalCall &call, void *userData, const PString &vxml, unsigned int options, OpalConnection::StringOptions *stringOptions=NULL)
Options and configuration
PSafePtr< OpalIVRConnection > | GetIVRConnectionWithLock (const PString &token, PSafetyMode mode=PSafeReadWrite)
const PString & | GetDefaultVXML () const
void | SetDefaultVXML (const PString &vxml)
void | SetDefaultMediaFormats (const OpalMediaFormatList &formats)
virtual void | OnEndDialog (OpalIVRConnection &connection)
void | SetDefaultTextToSpeech (const PString &tts)
PString | GetDefaultTextToSpeech () const
const PDirectory & | GetCacheDir () const
void | SetCacheDir (const PDirectory &dir)
void | SetRecordDirectory (const PDirectory &dir)
const PDirectory & | GetRecordDirectory () const

## Protected Attributes

PString | m_defaultVXML
OpalMediaFormatList | m_defaultMediaFormats
PString | m_defaultTTS
PMutex | m_defaultsMutex
PVXMLCache | m_ttsCache
PDirectory | m_recordDirectory

## Detailed Description

Interactive Voice Response endpoint.

## Constructor & Destructor Documentation

OpalIVREndPoint::OpalIVREndPoint | ( | OpalManager & | manager,
|  | const char * | prefix = `"ivr"` |
| ) |  |  |

Create a new endpoint.

Parameters:

  manager | Manager of all endpoints.
  prefix | Prefix for URL style address strings

OpalIVREndPoint::~OpalIVREndPoint | ( |  | ) |

Destroy endpoint.

## Member Function Documentation

virtual OpalIVRConnection* OpalIVREndPoint::CreateConnection | ( | OpalCall & | call,
|  | void * | userData,
|  | const PString & | vxml,
|  | unsigned int | options,
|  | OpalConnection::StringOptions * | stringOptions = `NULL` |
| ) |  |  | `[virtual]`

Create a connection for the PCSS endpoint. The default implementation is to create a OpalPCSSConnection.

Parameters:

  call | Owner of connection
  userData | Arbitrary data to pass to connection
  vxml | vxml to execute

const PDirectory& OpalIVREndPoint::GetCacheDir | ( |  | ) | const`[inline]`

Get the text to speach cache directory to use.

PString OpalIVREndPoint::GetDefaultTextToSpeech | ( |  | ) | const`[inline]`

const PString& OpalIVREndPoint::GetDefaultVXML | ( |  | ) | const`[inline]`

Get the default VXML to use.

PSafePtr<OpalIVRConnection> OpalIVREndPoint::GetIVRConnectionWithLock | ( | const PString & | token,
|  | PSafetyMode | mode = `PSafeReadWrite` |
| ) |  |  | `[inline]`

Find a connection that uses the specified token. This searches the endpoint for the connection that contains the token as provided by functions such as MakeConnection().

Parameters:

  token | Token to identify connection

virtual OpalMediaFormatList OpalIVREndPoint::GetMediaFormats | ( |  | ) | const`[virtual]`

Get the data formats this endpoint is capable of operating. This provides a list of media data format names that may be used by an OpalMediaStream may be created by a connection from this endpoint.

Note that a specific connection may not actually support all of the media formats returned here, but should return no more.

The default behaviour is pure.

Reimplemented from OpalLocalEndPoint.

const PDirectory& OpalIVREndPoint::GetRecordDirectory | ( |  | ) | const`[inline]`

virtual PVXMLCache& OpalIVREndPoint::GetTextToSpeechCache | ( |  | ) | `[inline, virtual]`

virtual PSafePtr<OpalConnection> OpalIVREndPoint::MakeConnection | ( | OpalCall & | call,
|  | const PString & | party,
|  | void * | userData = `NULL`,
|  | unsigned int | options = `0`,
|  | OpalConnection::StringOptions * | stringOptions = `NULL` |
| ) |  |  | `[virtual]`

Set up a connection to a remote party. This is called from the OpalManager::MakeConnection() function once it has determined that this is the endpoint for the protocol.

The general form for this party parameter is:

[proto:][alias@][transport$]address[:port]

where the various fields will have meanings specific to the endpoint type. For example, with H.323 it could be "h323:Fred@site.com" which indicates a user Fred at gatekeeper size.com. Whereas for the PSTN endpoint it could be "pstn:5551234" which is to call 5551234 on the first available PSTN line.

The proto field is optional when passed to a specific endpoint. If it is present, however, it must agree with the endpoints protocol name or false is returned.

This function usually returns almost immediately with the connection continuing to occur in a new background thread.

If false is returned then the connection could not be established. For example if a PSTN endpoint is used and the assiciated line is engaged then it may return immediately. Returning a non-NULL value does not mean that the connection will succeed, only that an attempt is being made.

The default behaviour is pure.

Parameters:

  call | Owner of connection
  party | Remote party to call
  userData | Arbitrary data to pass to connection
  options | options to pass to conneciton

Reimplemented from OpalLocalEndPoint.

virtual void OpalIVREndPoint::OnEndDialog | ( | OpalIVRConnection & | connection | ) | `[virtual]`

Called when VXML ends. Gives an opputunity for an application to do somthing when script ends, start a new script for instance.

Default action does nothing, session will end and connection will be released.

Parameters:

  connection | Connection with ending dialog

void OpalIVREndPoint::SetCacheDir | ( | const PDirectory & | dir | ) | `[inline]`

Set the text to speach cache directory to use.

void OpalIVREndPoint::SetDefaultMediaFormats | ( | const OpalMediaFormatList & | formats | ) |

Set the default media formats for all connections using VXML.

void OpalIVREndPoint::SetDefaultTextToSpeech | ( | const PString & | tts | ) | `[inline]`

Set/get the default text to speech engine used by the IVR

void OpalIVREndPoint::SetDefaultVXML | ( | const PString & | vxml | ) |

Set the default VXML to use.

void OpalIVREndPoint::SetRecordDirectory | ( | const PDirectory & | dir | ) | `[inline]`

## Field Documentation

OpalMediaFormatList OpalIVREndPoint::m_defaultMediaFormats `[protected]`

PMutex OpalIVREndPoint::m_defaultsMutex `[protected]`

PString OpalIVREndPoint::m_defaultTTS `[protected]`

PString OpalIVREndPoint::m_defaultVXML `[protected]`

PDirectory OpalIVREndPoint::m_recordDirectory `[protected]`

PVXMLCache OpalIVREndPoint::m_ttsCache `[protected]`

The documentation for this class was generated from the following file:

- ivr.h